unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Character, ExtCtrls, ComCtrls, World;


type
  TForm1 = class(TForm)
    Button1: TButton;
    Tm: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Sh: TImage;
    PcRunL: TImage;
    PcRunR: TImage;
    PcStandL: TImage;
    PcStandR: TImage;
    PcJumpL: TImage;
    PcJumpR: TImage;
    PcFallL: TImage;
    PcFallR: TImage;
    Label5: TLabel;
    Label6: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure TmTimer(Sender: TObject);
  private
    procedure ShowParameters;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Ch: TCharacter;
  Wr: TWorld;
  MaxH: Extended;
  FrameCount: Integer;
  FrameSwitch: Integer;
  PriorFrame: Boolean;

implementation

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
var
  I, J: Integer;
begin
  Form1.BorderStyle := bsNone;
  Form1.WindowState := wsMaximized;
  Wr := TWorld.Create(1 * 1024, 1 * 768);
  Wr.LoadMap('');
  Ch := TCharacter.Create(Wr, 46 - 12, 64 - 6, 10, 600);
  ShowMessage('Home, Delete, PageDown (Ctrl za trcanje)!' + #10#13);
  Application.ProcessMessages;
{  for I := 0 to Form1.ClientWidth do
    for J := 0 to Form1.ClientHeight do
      if not Wr.IsAvailablePos(I, J) then
        Form1.Canvas.Pixels[I, Form1.ClientHeight - J] := clBlack;}
  Sh.Picture.Assign(PcStandL.Picture);
  Tm.Enabled := True;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then
    Ch.GoLeft;
  if Key = VK_NEXT then
    Ch.GoRight;
  if Key = VK_HOME then
    Ch.GoJump;
  if Key = VK_CONTROL then
    Ch.GoRun;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then
    Ch.StopLeft;
  if Key = VK_NEXT then
    Ch.StopRight;
  if Key = VK_HOME then
    Ch.StopJump;
  if Key = VK_CONTROL then
    Ch.StopRun;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
end;

procedure TForm1.TmTimer(Sender: TObject);
begin
  Sh.Left := Ch.GetX - 6;
  Sh.Top := Form1.ClientHeight - Sh.Height - Ch.GetY + 3;
  Ch.Tick;
  if flgRunning in Ch.Flags then
    FrameSwitch := 3
  else
    FrameSwitch := 8;

  if flgJumping in Ch.Flags then
    Sh.Picture.Assign(TImage(Form1.FindComponent('PcJump' + Ch.Orient)).Picture)
  else
  if flgFalling in Ch.Flags then
    Sh.Picture.Assign(TImage(Form1.FindComponent('PcFall' + Ch.Orient)).Picture)
  else
    if not ((flgGoingLeft in Ch.Flags) or (flgGoingRight in Ch.Flags)) then
      Sh.Picture.Assign(TImage(Form1.FindComponent('PcStand' + Ch.Orient)).Picture)
    else
    begin
      if PriorFrame then
        Sh.Picture.Assign(TImage(Form1.FindComponent('PcRun' + Ch.Orient)).Picture)
      else
        Sh.Picture.Assign(TImage(Form1.FindComponent('PcStand' + Ch.Orient)).Picture);
      Inc(FrameCount);
      if FrameCount >= FrameSwitch then
      begin
        PriorFrame := not PriorFrame;
        FrameCount := 0;
      end;
    end;
  ShowParameters;
end;

procedure TForm1.ShowParameters;
begin
  Label1.Caption := 'X   = ' + FormatFloat(',000.0000', Ch.X);
  Label2.Caption := 'Y   = ' + FormatFloat(',000.0000', Ch.Y);
  Label3.Caption := 'Vx  = ' + FormatFloat(',000.0000', Ch.Vx);
  Label4.Caption := 'Vy  = ' + FormatFloat(',000.0000', Ch.Vy);
  Label4.Caption := 'PrX  = ' + FormatFloat(',000.0000', Ch.PriorX);
  Label5.Caption := 'PrY  = ' + FormatFloat(',000.0000', Ch.PriorY);
  Label8.Visible := flgFalling in Ch.Flags;
  Label9.Visible := flgJumping in Ch.Flags;

end;

end.
